"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.toBoolean = exports.isString = exports.isObjectFlat = exports.isEmptyObject = exports.isObject = exports.isArray = void 0;
const isArray = (item) => typeof item === 'object' && Array.isArray(item) && item !== null;
exports.isArray = isArray;
const isObject = (input) => input !== null && Object.prototype.toString.call(input) === '[object Object]';
exports.isObject = isObject;
const isEmptyObject = (input) => (0, exports.isObject)(input) && Object.keys(input).length === 0;
exports.isEmptyObject = isEmptyObject;
const isObjectFlat = (input) => {
    return ((0, exports.isObject)(input) &&
        Object.keys(input).every((key) => {
            const value = input[key];
            // Check if the value is an array
            if ((0, exports.isArray)(value)) {
                // Check if every element in the array is of an allowed type (string, number, boolean, or null)
                return value.every((element) => typeof element === 'string' ||
                    typeof element === 'number' ||
                    typeof element === 'boolean' ||
                    element === null);
            }
            // Check if the value is a non-null object (excluding arrays, which are also typeof 'object')
            return !(value && typeof value === 'object');
        }));
};
exports.isObjectFlat = isObjectFlat;
const isString = (input) => typeof input === 'string';
exports.isString = isString;
const toBoolean = (value) => {
    if (typeof value === 'string') {
        if (value.toLowerCase() === 'true') {
            return true;
        }
        else if (value.toLowerCase() === 'false') {
            return false;
        }
    }
    if ((0, exports.isArray)(value) && value.length === 0) {
        return false;
    }
    if ((0, exports.isObject)(value) && Object.keys(value).length === 0) {
        return false;
    }
    return Boolean(value);
};
exports.toBoolean = toBoolean;
