import { RestAPI } from '../api/api.js';
import { DEFAULT_TIMEOUT } from '../common/constants.js';
import { DBRecordInstance } from './record.js';
import { parseConfig, validateInteger } from './utils.js';
export const initSDK = (httpClient) => {
    class RushDB extends RestAPI {
        constructor(token, config) {
            var _a;
            const props = parseConfig(config);
            super(token, Object.assign(Object.assign({}, props), { httpClient: (_a = props.httpClient) !== null && _a !== void 0 ? _a : httpClient }));
            this.state = {
                debug: false,
                timeout: validateInteger('timeout', props.timeout, DEFAULT_TIMEOUT),
                token
            };
            this.models = new Map();
            RushDB.instance = this;
        }
        static getInstance() {
            return RushDB.instance;
        }
        registerModel(model) {
            const label = model.getLabel();
            // Inject the API into the model
            model.init(this);
            this.models.set(label, model);
            return model; //as unknown as Model<T['schema']> & Omit<RestAPI, 'find'>
        }
        getModels() {
            return this.models;
        }
        getModel(label) {
            return this.models.get(label);
        }
        toInstance(record) {
            const result = new DBRecordInstance(record);
            result.init(this);
            return result;
        }
    }
    return RushDB;
};
